**************
** LS -- List Structure Replacement.
** 
** John Koziol 9/10/99
**
** Version 1.1  -- January 12, 2000
** Version 1.11 -- February 4, 2000 
** Version 1.5  -- February 26, 2000
** Version 2.0  -- February 29, 2000
** Version 2.5  -- March 1, 2000
** Version 2.51 -- March 3, 2000
**
** PARAMETERS:  [lToPrint]  .F. or omitted:  List to screen
**									 .T.           :  Print
**
**************
#DEFINE DBT_DEATH				16
#DEFINE MSG_INVALIDPARM   	"Invalid parameter"
#DEFINE MSG_NODATA			"No table open"

PARAMETERS lToPrint

cTalk			= SET("TALK")
cSafety		= SET("SAFETY")

SET TALK OFF
SET SAFETY OFF

IF PARAMETERS() < 1 
   lToPrint=.F.
ENDIF
DO CASE
CASE VARTYPE(lToPrint) # "L"
   =MESSAGEBOX(MSG_INVALIDPARM,DBT_DEATH,"LS")
   RETURN
CASE EMPTY(ALIAS())
   cFile=GETFILE("DBF","Table","Open")
   IF EMPTY(cFile)
      =MESSAGEBOX(MSG_NODATA,DBT_DEATH,"LS")
      RETURN
   ENDIF
   SELECT 0
   USE (cFile)
ENDCASE
cOldAlias 	= ALIAS()
nTagcount	= TAGCOUNT(cOldAlias)   
nCursorType = CURSORGETPROP("SourceType")
cDatabase	= CURSORGETPROP("Database")
cAlias		= ALIAS()
IF !EMPTY(cDatabase)
	OPEN DATABASE (cDatabase) 
ENDIF
DO CASE
CASE nCursorType = 3
   cDBF=FULLPATH(DBF())
	nRecs				= RECCOUNT()
	nCPDBF	  		= CPDBF()
	dLUpdate			= LUPDATE()
CASE nCursorType = 2
   cDBF				= ALIAS()+" (Remote)"
   cConnection 	= CURSORGETPROP("ConnectName")
   cConnectHandle	= TRANS(CURSORGETPROP("ConnectHandle"))
   cSQL				= CURSORGETPROP("SQL")
   cParameters 	= DBGETPROP(ALIAS(),"VIEW","ParameterList")
   cBatchUpdCnt	= TRANS(CURSORGETPROP("BatchUpdateCount"))
   cCompareMemo   = IIF(CURSORGETPROP("CompareMemo"),"Yes","No")
   cFetchAsNeeded = IIF(CURSORGETPROP("FetchAsNeeded"),"Yes","No")
   cFetchMemo		= IIF(CURSORGETPROP("FetchMemo"),"Yes","No")
   cFetchSize		= TRANS(CURSORGETPROP("FetchSize"))
   cMaxRecords		= IIF(CURSORGETPROP("MaxRecords")=-1,"All",TRANS(CURSORGETPROP("MaxRecords")))
   cPrepared		= IIF(CURSORGETPROP("Prepared"),"Yes","No")
   cSendUpdates	= IIF(CURSORGETPROP("SendUpdates"),"Yes","No")
   cSourceName		= CURSORGETPROP("SourceName")
   cTables			= CURSORGETPROP("Tables")
   cUpdateType		= IIF(CURSORGETPROP("UpdateType")=1,"Update","Insert/Delete")
   cUseMemoSize	= TRANS(CURSORGETPROP("UseMemoSize"))
   cWhereType		= TRANS(CURSORGETPROP("WhereType"))
CASE nCursorType = 1
   cDBF				= ALIAS()+" (Local)"
   cConnection		= ""
   cConnectHandle	= "NA"
   cSQL				= CURSORGETPROP("SQL")
   cParameters 	= DBGETPROP(ALIAS(),"VIEW","ParameterList")
   cBatchUpdCnt   = "NA"
   cCompareMemo   = IIF(CURSORGETPROP("CompareMemo"),"Yes","No")
   cFetchAsNeeded = IIF(CURSORGETPROP("FetchAsNeeded"),"Yes","No")
   cFetchMemo		= "NA"
   cFetchSize 		= "NA"
   CMaxRecords		= "NA"
   cPrepared		= IIF(CURSORGETPROP("Prepared"),"Yes","No")
   cSendUpdates	= IIF(CURSORGETPROP("SendUpdates"),"Yes","No")
   cSourceName		= CURSORGETPROP("SourceName")
   cTables			= CURSORGETPROP("Tables")
   cUpdateType		= IIF(CURSORGETPROP("UpdateType")=1,"Update","Insert/Delete")
   cUseMemoSize	= "NA"
   cWhereType		= TRANS(CURSORGETPROP("WhereType"))
ENDCASE
cStru=SYS(2015)
COPY STRU EXTE TO (cStru)
USE (cStru) IN 0 ALIAS curStruct EXCL
ALTER TABLE curStruct ADD COLUMN field_stru C(10) ADD COLUMN objtype C(10) ADD COLUMN objno N(3.0)
SELECT curStruct
LOCA
cTable_cmt	= table_cmt
SCAN
   DO CASE
   CASE field_type = "C"
      REPLACE field_stru WITH "C("+TRANS(field_len)+")"
   CASE field_type $ "NF"
      REPLACE field_stru WITH field_type+"("+TRANS(field_len)+","+TRANS(field_dec)+")"
   CASE field_type = "B"
      REPLACE field_stru WITH "B("+TRANS(field_dec)+")"
   OTHERWISE
      REPLACE field_stru WITH field_type
   ENDCASE
   IF nCursorType = 3
	   REPLACE objtype WITH "TABLE",objno WITH RECNO()
	ELSE
	   cFieldPath=ALLT(cOldAlias)+"."+ALLT(field_name)
	   REPLACE objtype WITH "CURSOR",objno WITH RECNO(),;
	           field_nocp WITH DBGETPROP(cFieldPath,"FIELD","Updatable"),;
	           field_defa WITH DBGETPROP(cFieldPath,"FIELD","UpdateName")
	   IF DBGETPROP(cFieldPath,"FIELD","KeyField")
	      REPLACE field_name WITH ALLT(field_name)+" (Key)"
	   ENDIF
	ENDIF
ENDSCAN
FOR i = 1 TO nTagCount
   cTag_Name = UPPER(TAG(i,cOldAlias))
   cTag_Name = cTag_Name+IIF(PRIMARY(i,cOldAlias)," (Primary)","")
   cTag_Name = cTag_Name+IIF(CANDIDATE(i,cOldAlias)," (Candidate)","")
   cTag_Expr = SYS(14,i,cOldAlias)
   INSERT INTO curStruct (objtype,field_name,field_defa,objno) VALUES ;
                         ("STRUCTTAG",cTag_Name,cTag_Expr,i)
ENDFOR
IF !EMPTY(cDatabase)
   =ADBOBJECTS(aViews,"VIEW")
   =ADBOBJECTS(aRelations,"RELATION")
   IF VARTYPE(aViews) # "U"
      FOR i = 1 TO ALEN(aViews,1)
         nParticipates = AT(UPPER(cOldAlias),UPPER(DBGETPROP(aViews[i],"VIEW","SQL")))
         IF nParticipates > 0
            cSQL=DBGETPROP(aViews[i],"VIEW","SQL")
            INSERT INTO curStruct (objtype,field_name,field_defa,objno) VALUES ("VIEW",aViews[i],cSQL,0)
         ENDIF
		ENDFOR     
   ENDIF
   IF VARTYPE(aRelations) # "U"
      FOR i = 1 TO ALEN(aRelations,1)
         nParticipates = IIF(UPPER(cOldAlias)=UPPER(aRelations[i,1]) OR ;
                             UPPER(cOldAlias)=UPPER(aRelations[i,2]),1,0)
         IF nParticipates > 0
            lIsParent=(UPPER(cOldAlias)=UPPER(aRelations[i,2]))
            IF lIsParent
               cRelTable=UPPER(aRelations[i,1])
               cRelTag="("+aRelations[i,3]+")"
               cThisTag="("+aRelations[i,4]+")"
            ELSE
               cRelTable=UPPER(aRelations[i,2])
               cRelTag="("+aRelations[i,4]+")"
               cThisTag="("+aRelations[i,3]+")"
            ENDIF
            cFieldText = UPPER(cOldAlias)+cThisTag+;
            				 " is a "+IIF(lIsParent,"parent","child")+" to "+;
                         cRelTable+cRelTag
            cFieldStru = UPPER(aRelations[i,5])
            INSERT INTO curStruct (objtype,field_name,field_stru,objno) VALUES ;
                                  ("RELATION",cFieldText,cFieldStru,0)
         ENDIF
      ENDFOR
   ENDIF
ENDIF
IF EMPTY(cDatabase)
   cDatabase="Free table"
ENDIF   
LOCATE
cReportName=IIF(nCursorType=3,"LS","LSV")
IF lToPrint
   REPORT FORM &cReportName NOCONSOLE TO PRINT
ELSE
	REPORT FORM &cReportName
ENDIF
USE IN curStruct
cDBF=cStru+".DBF"
cFPT=cStru+".FPT"
cBAK=cStru+".BAK"
cTBK=cStru+".TBK"
DELETE FILE &cDBF
DELETE FILE &cFPT
DELETE FILE &cBAK
DELETE FILE &cTBK
SELECT (cOldAlias)
SET TALK &cTalk
SET SAFETY &cSafety
RETURN



